;|===========================================================================|
;|                               MULTIPLICATION                              |
;| This routine multiplies the numbers A and B in floating point arithmetic. |
;| Each number A and B are stored into 5 bytes of ram space. The result is   |
;| saved into 16 bytes of ram space. In this routine, the point position of  |
;| the resultant multiplication is fixed.                                    |
;|===========================================================================|

multicn  ldi a,pointr0
         sub a,pointa
         sub a,pointb
         inc a
         ld addr_r,a         ; Save the lsb address of the resultant
                             ; multiplcation. 
         ldi addr_a,lsb_a    ; Save the lsb address of the number A.
         ldi y,lsb_a         ; Load the lsb address of the number A.
         ldi byte_num,05h    ; Load the byte number has to be multiplied.
multic1  ld a,(y)
         jrnz multic2        ; Test if the byte of the number A = 0 ?
         jp multic8
multic2  ldi x,lsb_b         ; Load the lsb address of the number B.
         ld a,addr_r
         ld y,a              ; Load the address of the resultant
                             ; multiplication byte.
multic3	 ld a,(x)
         add a,(y)           ; Byte B + resultant multiplication byte .
         ld (y),a            ; Store into resultant multiplication byte.
         subi a,0ah          ; Test if the result < 10.
         jrc multic4
         ld (y),a
multic4  inc y               ; Next resultant multiplication byte.
         jrc multic5
         inc (y)             ; Store the carry into the next resultant
                             ; multiplication byte.
multic5  ld a,y
         cpi a,msb_r
         jrc multic6
	 jp erreur
multic6  ld a,x
         cpi a,msb_b         ; Test if all bytes of the number B are added ?
         jrnc multic7
         inc x               ; Next number B byte.
         jp multic3
multic7  ld a,addr_a
         ld y,a
         dec (y)             ; Decremente the number A byte.
         jp multic1 
multic8  inc addr_a          ; Next number A byte.
         ld a,addr_a
         ld y,a
         inc addr_r          ; Shift left the lsb of the resultant
                             ; multiplication.
         dec byte_num
         jrz multic9         ; Test for the end of multiplication ?
         jp multic1
multic9  set mult_val,ope_flag
         jp end_mult
erreur   res mult_val,ope_flag
end_mult ret 
