;*****************************************************************************
;*                                                                           *
;*                ST6 PORTS WITH INTERRUPTIONS                               *
;*                                                                           *
;*****************************************************************************

;|===========================================================================|
;| Assembly method without linker : ast6 -l -s -m -e example1.asm            |
;|===========================================================================|

;|===========================================================================|
;|                          Assembly directives                              |
;|===========================================================================|

	 .title	"ST6 PORTS WITH It"   ; This directive defines a new title to be
				  ; in the page header of the output listing.
	 .vers "st6215"
	 .romsize 2

;*****************************************************************************
;*                              data space                                   *
;*****************************************************************************

;|===========================================================================|
;|                           data registers                                  |
;|===========================================================================|

         .input "6215_reg.asm"

;|===========================================================================|
;|                            constants definition                           |
;|===========================================================================|

count	 .equ 0fah
watchtim .equ 0feh

;bit timer
;---------
tmz      .equ 7                   ; This bit must be cleared by user software
				  ; before to start with a new count.
dout     .equ 4                   ; Data sent to the timer output  when tms
				  ; is set hight.

;*****************************************************************************
;*                             PROGRAM SPACE                                 *
;*****************************************************************************

;|===========================================================================|
;|                             main program                                  |
;|===========================================================================|

	 .org 880h
;**************************************************************************
;*  CONFIGURATION of port A in input with interrupt (DDRA=0,DRA=0,ORA = 1)
;**************************************************************************
reset	 ldi ddra,04              ; Load the data direction register port A
	 ldi dra,0		  ; Load data register port A 
	 ldi ora,02		  ; Load option register port A
;**************************************************************************
;*  Enable the interrupts => IOR = 10h && reti (quit NMI mode after reset)
;**************************************************************************
	 ldi ior,10h              ; Enables all interrupts.
	 reti  			  ; Quit NMI mode after reset

loop	 wait
	 jp loop

;|===========================================================================|
;|                          interrupt routine                                |
;|===========================================================================|
it_porta ld  a,dra
	 sla a
	 ld  dra,a
	 reti

;*****************************************************************************
;*                     Restart and interrupt Vectors                         *
;*****************************************************************************

	 .org 0ff0h

adc      nop
	 reti
timer    nop
	 reti
portb    nop
         reti
porta    jp it_porta
	 nop
	 nop
	 nop
	 nop
nmi      nop
	 reti
res      jp reset
