;*****************************************************************************
;*                                                                           *
;*                             ST6 PORT A                                    *
;*                                                                           *
;*****************************************************************************

;|===========================================================================|
;| Assembly method without linker : ast6 -l -s -x -m -e example1.asm         |
;|===========================================================================|

;|===========================================================================|
;|                          Assembly directives                              |
;|===========================================================================|

	 .title	"ST6 PORT A"   ; This directive defines a new title to be
				  ; in the page header of the output listing.
	 .vers "st6215"
	 .romsize 2

;*****************************************************************************
;*                              data space                                   *
;*****************************************************************************

;|===========================================================================|
;|                           data registers                                  |
;|===========================================================================|

         .input "6215_reg.asm"

;|===========================================================================|
;|                            constants definition                           |
;|===========================================================================|

count	 .equ 0fah
watchtim .equ 0feh

;bit timer
;---------
tmz      .equ 7                   ; This bit must be cleared by user software
				  ; before to start with a new count.
dout     .equ 4                   ; Data sent to the timer output  when tms
				  ; is set hight.

;*****************************************************************************
;*                             PROGRAM SPACE                                 *
;*****************************************************************************

;|===========================================================================|
;|                             main program                                  |
;|===========================================================================|

	 .org 880h
;**************************************************************************
;*  CONFIGURATION of port A in input (DDRA,DRA,ORA = 0)
;**************************************************************************
reset	 ldi ddra,0               ; Load the data direction register port A
	 ldi dra,0		  ; Load data register port A 
	 ldi ora,0		  ; Load option register port A
;**************************************************************************
;*  Enable the interrupts => IOR = 10h && reti (quit NMI mode after reset)
;**************************************************************************
	 ldi ior,10h              ; Enables all interrupts.
	 reti  			  ; Quit NMI mode after reset
;**************************************************************************
;*  CONFIGURATION of port B in output (DDRB = 1,DRB = value,ORB = 0)
;**************************************************************************
output	 ldi ddrb,0FFh             ; Load the data direction register port B
	 ldi orb,0		  ; Load option register port B
	 ldi drb,0		  ; Load data register port B with value
	 ldi drb,0FFh		  ; Output value FF
	 ldi drb,00h		  ; Output value 00 (reset the port)
	 ldi drb,0aah		  ; Output value aa
	 ldi drb,55h		  ; Output value 55
	 ldi drb,00h		  ; Output value 00
	 ldi drb,0FFh		  ; Output value FF
	 ldi drb,00h		  ; Output value 00


;|===========================================================================|
;|                          interrupt routine                                |
;|===========================================================================|

;*****************************************************************************
;*                     Restart and interrupt Vectors                         *
;*****************************************************************************

	 .org 0ff0h

adc      nop
	 reti
timer    nop
	 reti
portb    nop
         reti
porta    nop
	 reti
	 nop
	 nop
	 nop
	 nop
nmi      nop
	 reti
res      jp reset
